<?php

/**
 * ljn functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package ljn
 */

// Include SVG sprite functions
// require_once get_template_directory() . '/theme/inc/svg-sprite.php';

if (!defined('LJN_VERSION')) {
	/*
	 * Set the theme’s version number.
	 *
	 * This is used primarily for cache busting. If you use `npm run bundle`
	 * to create your production build, the value below will be replaced in the
	 * generated zip file with a timestamp, converted to base 36.
	 */
	define('LJN_VERSION', '0.1.3');
}

if (!defined('LJN_TYPOGRAPHY_CLASSES')) {
	/*
	 * Set Tailwind Typography classes for the front end, block editor and
	 * classic editor using the constant below.
	 *
	 * For the front end, these classes are added by the `ljn_content_class`
	 * function. You will see that function used everywhere an `entry-content`
	 * or `page-content` class has been added to a wrapper element.
	 *
	 * For the block editor, these classes are converted to a JavaScript array
	 * and then used by the `./javascript/block-editor.js` file, which adds
	 * them to the appropriate elements in the block editor (and adds them
	 * again when they’re removed.)
	 *
	 * For the classic editor (and anything using TinyMCE, like Advanced Custom
	 * Fields), these classes are added to TinyMCE’s body class when it
	 * initializes.
	 */
	define(
		'LJN_TYPOGRAPHY_CLASSES',
		'prose prose-neutral max-w-none prose-a:text-primary'
	);
}

if (!function_exists('ljn_setup')) :
	/**
	 * Sets up theme defaults and registers support for various WordPress features.
	 *
	 * Note that this function is hooked into the after_setup_theme hook, which
	 * runs before the init hook. The init hook is too late for some features, such
	 * as indicating support for post thumbnails.
	 */
	function ljn_setup()
	{
		/*
		 * Make theme available for translation.
		 * Translations can be filed in the /languages/ directory.
		 * If you're building a theme based on ljn, use a find and replace
		 * to change 'ljn' to the name of your theme in all the template files.
		 */
		load_theme_textdomain('ljn', get_template_directory() . '/languages');

		// Add default posts and comments RSS feed links to head.
		add_theme_support('automatic-feed-links');

		/*
		 * Let WordPress manage the document title.
		 * By adding theme support, we declare that this theme does not use a
		 * hard-coded <title> tag in the document head, and expect WordPress to
		 * provide it for us.
		 */
		add_theme_support('title-tag');

		/*
		 * Enable support for Post Thumbnails on posts and pages.
		 *
		 * @link https://developer.wordpress.org/themes/functionality/featured-images-post-thumbnails/
		 */
		add_theme_support('post-thumbnails');

		add_image_size('ljn_card_realisation_portrait', 900, 1200, true);

		// This theme uses wp_nav_menu() in two locations.
		register_nav_menus(
			array(
				'menu-header' => __('Header', 'ljn'),
				'menu-footer' => __('Footer', 'ljn')
			)
		);

		/*
		 * Switch default core markup for search form, comment form, and comments
		 * to output valid HTML5.
		 */
		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'style',
				'script',
			)
		);

		// Add theme support for selective refresh for widgets.
		add_theme_support('customize-selective-refresh-widgets');

		// Add support for editor styles.
		add_theme_support('editor-styles');

		// Enqueue editor styles.
		add_editor_style('style-editor.css');

		// Add support for responsive embedded content.
		add_theme_support('responsive-embeds');

		// Remove support for block templates.
		remove_theme_support('block-templates');
	}
endif;
add_action('after_setup_theme', 'ljn_setup');

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function ljn_widgets_init()
{
	register_sidebar(
		array(
			'name'          => __('Footer', 'ljn'),
			'id'            => 'sidebar-1',
			'description'   => __('Add widgets here to appear in your footer.', 'ljn'),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action('widgets_init', 'ljn_widgets_init');

/**
 * Enqueue scripts and styles.
 */
function ljn_scripts()
{
	wp_enqueue_style('ljn-style', get_stylesheet_uri(), array(), LJN_VERSION);
	wp_enqueue_script('ljn-script', get_template_directory_uri() . '/js/script.min.js', array(), LJN_VERSION, true);

	if (is_singular() && comments_open() && get_option('thread_comments')) {
		wp_enqueue_script('comment-reply');
	}
}
add_action('wp_enqueue_scripts', 'ljn_scripts');

/**
 * Enqueue the block editor script.
 */
function ljn_enqueue_block_editor_script()
{
	wp_enqueue_script(
		'ljn-editor',
		get_template_directory_uri() . '/js/block-editor.min.js',
		array(
			'wp-blocks',
			'wp-edit-post',
		),
		LJN_VERSION,
		true
	);
}
add_action('enqueue_block_editor_assets', 'ljn_enqueue_block_editor_script');

/**
 * Create a JavaScript array containing the Tailwind Typography classes from
 * LJN_TYPOGRAPHY_CLASSES for use when adding Tailwind Typography support
 * to the block editor.
 */
function ljn_admin_scripts()
{
?>
	<script>
		tailwindTypographyClasses = '<?php echo esc_attr(LJN_TYPOGRAPHY_CLASSES); ?>'.split(' ');
	</script>
<?php
}
add_action('admin_print_scripts', 'ljn_admin_scripts');

// add_filter('wp_img_tag_add_auto_sizes', function ($add, $image, $context) {
// 	if (strpos($image, 'class="') !== false && strpos($image, 'card-image') !== false) {
// 		return false;
// 	}
// 	return $add;
// }, 10, 3);

/**
 * Add the Tailwind Typography classes to TinyMCE.
 *
 * @param array $settings TinyMCE settings.
 * @return array
 */
function ljn_tinymce_add_class($settings)
{
	$settings['body_class'] = LJN_TYPOGRAPHY_CLASSES;
	return $settings;
}
add_filter('tiny_mce_before_init', 'ljn_tinymce_add_class');

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/inc/template-functions.php';

/**
 * Custom post type
 */
require get_template_directory() . '/inc/cpt.php';


add_action('init', function() {
    if( function_exists('acf_add_options_page') ) {

        acf_add_options_page(array(
            'page_title'    => 'Paramètres',
            'menu_title'    => 'Paramètres',
            'menu_slug'     => 'theme-general-settings',
            'capability'    => 'edit_posts',
            'redirect'      => false,
            'position'      => 4,
        ));

    }
}, 20);


function isLocalhost() {
    $whitelist = array('127.0.0.1', '::1','https://atelier-ljn.local/');
    return in_array($_SERVER['REMOTE_ADDR'], $whitelist);
}


add_filter('wpseo_whitelist_permalink_vars', function ($vars) {
	$vars[] = 'avant_premiere';
	return $vars;
});



if(isset($_GET['avant_premiere']) && $_GET['avant_premiere'] === '1') {
	setcookie('avant_premiere', '1', time() + (86400 * 10), '/'); // 30 days
}

if(isset($_GET['avant_premiere']) && $_GET['avant_premiere'] === '0') {
	setcookie('avant_premiere', '0', time() + (86400 * 10), '/');
	unset($_COOKIE['avant_premiere']);
}


function isAvantPremiere() {
	if (isset($_COOKIE['avant_premiere']) && $_COOKIE['avant_premiere'] === '1' ) {
		return true;
	}
	return false;
}

add_filter('body_class', function ($classes) {
	// if (isAvantPremiere()) {
		$classes[] = 'is-avant-premiere';
	// }

	if (is_front_page()) {
		$classes[] = 'is-cover-video-in-viewport';
	}
	return $classes;
});
